#ifndef __SOUNDGEN_H__
#define __SOUNDGEN_H__

class Sound {
public:
	Sound();
	void setSound(int, float, float);
        void setNote(int);
	float sineGen();
	float sawGen();
	float squareGen();
	float triangleGen();
	float noiseGen();
	float midiToFreq(int);
        float getOut();
private:
	int bitDepth;
	float sampleRate;
	float noteFreq;
	float outS;
	float out;
	float maxAmplitude;
	unsigned short int triangleCtrl;
};

class SoundFX {
public:
	SoundFX();
	float panner(float, float, float, short);
	float ampMono(float, float);
	float ampStereo(float, float, float, short);
	float monoToStereo(float, float, float, short);
	float stereoToMono(float, float, float, float);
	float cross(float, float, float, short);
private:
	float outM;
	float outL;
	float outR;
	short chCheck;
};

class ADSR {
public:
	ADSR();
	void setEnvelope(float, float, float, float, float);
	void turnOn();
	float runEnvelope(float);
	void turnOff();
	void resetCount();
        void setAttackTime(float);
        void setDecayTime(float);
        void setSustain(float);
        void setReleaseTime(float);
        float getAttackTime();
        float getAttackSamples();
        float getDecayTime();
        float getDecaySamples();
        float getSustain();
        float getReleaseTime();
        float getReleaseSamples();
private:
	float sampleRate;
        unsigned long int attackSamples;
        unsigned long int decaySamples;
	float sustainVol;
        unsigned long int releaseSamples;
	float out;
	float amplitudeOut;
	unsigned long int sampleCount;
	unsigned long int afterCount;
	bool noteOn;
};

#endif
